100 REM Parses output of "findtop.bas" and benchmarks top-scoring warriors
102 REM against another test set.
110 REM Settings in rebench.ini file. WTN 7/29/09
120 usewin=1   'set to 1 for Windows, 0 for Linux
130 open "rebench.ini" for input as #1
135 while not eof(1)
140 line input #1,a$
141 if right$(a$,1)=chr$(13) then a$=left$(a$,len(a$)-1)
142 if left$(a$,9)="toplist :" then toplist$=mid$(a$,10):print "toplist=";toplist$
143 if left$(a$,9)="testdir :" then testdir$=mid$(a$,10):print "testdir=";testdir$
144 if left$(a$,9)="testmask:" then testmask$=mid$(a$,10):print "testmask=";testmask$
145 if left$(a$,9)="report  :" then report$=mid$(a$,10):print "report=";report$
146 if left$(a$,9)="rounds  :" then rounds=val(mid$(a$,10)):print "rounds=";str$(rounds)
147 if left$(a$,9)="mars    :" then sim$=mid$(a$,10):print "mars=";sim$
148 if left$(a$,9)="marsopts:" then simopts$=mid$(a$,10):print "marsopts=";simopts$
150 wend:close #1
160 if toplist$="" or testdir$="" or testmask$="" or report$="" then goto 180
165 if rounds <= 0 or (instr(sim$,"mars")=0 and instr(sim$,"MARS")=0) then goto 180
170 if simopts$="" then goto 180 else goto 200
180 print "Error in rebench.ini file":system
190 REM ---------------------------------------------------------------
200 sim$=sim$+" -b -k "+simopts$+" -r "+str$(rounds)+" ":print "Press Esc to stop"
210 if usewin then dc$="dir /b /on ":ps$="\" else dc$="ls -1 ":ps$="/"
230 shell dc$+testdir$+ps$+testmask$+" > testlist.tmp"
240 open report$ for output as #1:topscore=0:top$=""
250 open toplist$ for input as #2
260 while not eof(2) and inkey$<>chr$(27)
270  score=0:n=0
280  line input #2,war$:if left$(war$,8)<>"Warrior " then goto 440
282  war$=mid$(war$,9):z=instr(war$," scores"):if z<2 then goto 440
284  war$=left$(war$,z-1)
290  open "testlist.tmp" for input as #3
300  while not eof(3)
310   line input #3,opp$:if usewin then opp$=testdir$+ps$+opp$
320   shell sim$+war$+" "+opp$+" >scores.tmp"
330   open "scores.tmp" for input as #4
340   line input #4,a$:close #4
350   z=instr(a$," "):w=val(left$(a$,z)):t=val(mid$(a$,z))
360   score=score+w*3+t:n=n+1
370  wend
380  close #3
390  score=(score/n)*(100/rounds)
400  if score>topscore then topscore=score:top$=war$
410  sc$=mid$(str$(-1*(1000+score+.00001))+"     ",3,6)
420  print sc$;"  ";war$
430  print #1,sc$;"  ";war$
440 wend
450 close #1:close #2
460 kill "testlist.tmp":kill "scores.tmp"
470 print "Top score = ";str$(topscore);" by ";top$
480 system
