;redcode-94lp
;name Philosopher's Stone
;author John Metcalf
;strategy Stone/Imp for Pizza's limited process hill
;strategy 4 processes in stone, 4 in imp
;assert 1
;optimax sai

iStep equ 267
sStep equ 314

     spl   1,        {687   ; make 8
     spl   1,        {615   ; processes
     spl   1,        {91
     jmp   *vect,    }0      ; launch

vect:jmp   #off+1,   1       ; 4 processes
     jmp   #off+2,   1       ; in stone
     jmp   #off+3,   1
     jmp   #off+1,   1

     jmp   #imp,        1    ; and 4 in
     jmp   #imp+iStep,  1    ; the imp
     jmp   #imp+iStep*2,1
     jmp   #imp+iStep*3,1

     for   5
     dat   0,0
     rof

off: spl   #sStep,   <-sStep
sto: mov   >sStep,   1-sStep ; incremented
     add   off,      sto
     jmp   sto,      off     ; incremented

     for   5
     dat   0,0
     rof

imp  mov.i #iStep,   *0
     end
